
#include <stdio.h>
#include <stdlib.h>

static const char *cp1251[256] =
{ "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
  " ", "!", "\"", "#", "$", "%", "&amp;", "'", "(", ")", "∗", "+", ",", "−", ".", "/",
  "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", ";", "&lt;", "=", "&gt;", "?",
  "@", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O",
  "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "[", "\\", "]", "^", "_",
  "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o",
  "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "{", "|", "}", "∼", "",
  "Ђ", "Ѓ", "‚", "ѓ", "„", "…", "†", "‡", "€", "‰", "Љ", "‹", "Њ", "Ќ", "Ћ", "Џ",
  "ђ", "‘", "’", "“", "”", "•", "–", "—", "", "™", "љ", "›", "њ", "ќ", "ћ", "џ",
  "&nbsp;", "Ў", "ў", "Ј", "¤", "Ґ", "¦", "§", "Ё", "©", "Є", "«", "¬", "&shy;", "®", "Ї",
  "°", "±", "І", "і", "ґ", "µ", "¶", "·", "ё", "№", "є", "»", "ј", "Ѕ", "ѕ", "ї",
  "А", "Б", "В", "Г", "Д", "Е", "Ж", "З", "И", "Й", "К", "Л", "М", "Н", "О", "П",
  "Р", "С", "Т", "У", "Ф", "Х", "Ц", "Ч", "Ш", "Щ", "Ъ", "Ы", "Ь", "Э", "Ю", "Я",
  "а", "б", "в", "г", "д", "е", "ж", "з", "и", "й", "к", "л", "м", "н", "о", "п",
  "р", "с", "т", "у", "ф", "х", "ц", "ч", "ш", "щ", "ъ", "ы", "ь", "э", "ю", "я"
};

static unsigned char line[512];

void Anchor(void)
{ int i=2;
  fputs("<a id=\"",stdout);
  while(line[i]>32)
  { fputs(cp1251[line[i]],stdout);
    ++i;
  }
  fputs("\">",stdout);
}

int main(int arc, char *argv[])
{ FILE *f = fopen(argv[1],"rb");
  int ln=1;
  fprintf(stderr, "listmkp v0.1a (c) AtH, 3 июля 2016, Файл: %s\n",argv[1]);
  if (f!=NULL)
  { printf(
"<!DOCTYPE html>\n"
"<html>\n"
"  <head>\n"
"    <title>Файл: %s</title>\n"
"    <meta charset=\"utf-8\">\n"
"  </head>\n"
"  <body><pre>", argv[1]);
    while(fgets((char *)line, 512, f)!=NULL)
    { int i=0, x=0;
      unsigned char c=0;
      if ((line[0]==';') && (line[1]=='#'))
      { Anchor();
        printf("%4i</a> ", ln);
      } else printf("%4i ", ln);
      while((c=line[i])!='\0')
      { if (c!=9) fputs(cp1251[c],stdout), ++x;
        else
        { do { fputs(cp1251[32],stdout); ++x; }
          while ((x&7)!=0);
        }
        ++i;
      }
      puts("");
      ++ln;
    }
    fclose(f);
    puts(
"</pre>\n"
"  </body>\n"
"</html>");
  } else fprintf(stderr,
  "Не найден файл '%s'.\n"
  "Использование: listmkp имя-файла\n",argv[1]);
}


